/**
 * The application's bootstrap code for javascript
 */
var Bootstrap = new Class({

	initialize: function()
	{
		/**
		 * Nav
		 */
		Nav.options = {
			home: 			'default'
		};

		// Instantiate Pagers
		Nav.pagers = new Nav.Pagers({
			background: 'Page-wrap4',
			backgroundPositionStatic: '-120px top',
			getPagerLinks: function(urlBase){
				return Website.mainMenu.getPagerLinks(urlBase);
			}
		});

		// Highlighter
		Nav.highlighter = new Nav.Highlighter();

		/**
		 * Hijax
		 */
		Hijax.options = {
			home: 			Nav.options.home,
			idPrefix: 		'Hijax-level',
			ajaxBaseUrl: 	'/pages/',

			/**
			 * This is an array of terminal controllers, meaning that they are the URLs
			 * pointing to a valid controller but anything following these URLs represents
			 * an "id" of some dynamically generated content.
			 *
			 * E.g. 1.	/rates/diving is a controller itself so would feature here
			 * 		2.	/travel/mozambique-2011 points to dynamic content so we specify
			 * 			/travel below
			 */
			hasDynamicContent: [
                'blog',
                'rates/vouchers',
                'gallery'
            ]
		};

		// Toggle Hijax busy based on navbusy event
		window.addEvent('navbusy', function(busy){
			Hijax.busy = !!busy;
		}.bind(this));

		/**
		 * Website
		 */
        Website.preload = new Website.Preload();

		Website.titler = new Website.Titler.Hijax({
			title: Website.title,
			separator: Website.titleSeparator,
			position: Website.titlePosition
		});

		Website.mainMenu = new Website.MainMenu({
			menuLinks: 		$$('#Menu a[href^=/]')
		});

		Website.logo = new Website.Logo({
			logoLinks:		$$('#Logo a[href^=/]')
		});

		Website.busy = new Website.Busy({
			busyTopId:		'Busy-top'
		});

		Website.slides = new Website.Slides({
			mainMenu:		Website.mainMenu
		});

		var contentSetter = function(container, html)
		{
			html = Website.titler.from(html);
			container.set('html', html);
		};

		Website.displayBase = new Website.DisplayBase({
			idealDuration: 2000,
			ajaxBaseUrl: Hijax.options.ajaxBaseUrl,
			baseContainerId: 'Hijax-level0',
			loadingElementId: 'Hijax-loading',
			caretElementId: 'Caret',
			backgroundId: 'Background',
			slides: Website.slides,
			caret: {
			    duration: 600,
			    transition: Fx.Transitions.Back.easeOut
			},
			content: {
				duration: 1000,
			    transition: Fx.Transitions.Linear
			},
			background: {
				duration: 1600,
			    transition: Fx.Transitions.Linear
			},
			contentSetter: contentSetter
		});

		Website.displaySub = new Website.DisplaySub({
			ajaxBaseUrl: Hijax.options.ajaxBaseUrl,
			containerFx: {
			    duration: '200',
			    transition: 'linear',
			    property: 'opacity'
			},
			contentSetter: contentSetter
		});

		Website.nav = new Website.Nav({
			nav:			Nav.instance(),
			mainMenu:		Website.mainMenu,
			displayBase:	Website.displayBase,
			displaySub:		Website.displaySub
		});

		Hijax.load = function(request, container, mappedUrl, hijack)
		{
			Website.nav.load(request, container, mappedUrl, hijack);
		};

		// Hijax mode is automatic but can be forced to Old mode for debug
		History.forceOldMode = false;

		LightBox.lightBox = new LightBox.LightBox();


		document.body.addEvent('click:relay([data-code])', function(e){
			var item = this;
			if(e.target.tagName.toLowerCase() != 'input')
			{
				var code = item.get('data-code');
				LightBox.lightBox.show(code,item);
			}

		});

		var galog = function(url)
		{
			var url = '/' + url.replace('_', '/');
			_gaq.push(['_trackPageview', url]);
		}

		window.addEvent('pageloaded', function(url){
			galog(url);
		});

		window.addEvent('fakeurlloaded', function(url){
			galog(url);
		});
	},

	start: function()
	{
		// Menu hover effect
		Website.mainMenu.hoverStart();

		// Hijax
		Hijax.instance().start();

		window.fireEvent('started');
	}

});

window.addEvent('domready', function(){
	new Bootstrap().start();
});

function PADIeLearning() {
	var aqua_ventures = '3299';
	accessWin = window.open('https://www.padi.com/padi/elearning/default.aspx?irra='+aqua_ventures,'','scrollbars=yes,top='+(screen.height/8)+',left='+(screen.width/8)+',width=1000,height=700,resizable=yes');
	window.accessWin.focus();
}