var Pages = Pages || {};
/**
 * Pages.Abstract
 * 
 * @package 	Pages
 */
Pages.Abstract = new Class({
	
	Implements: [Options],
	
	options: {
		place: ''
	},
	
	log: $L.from('Pages'),
	
	initialize: function(options)
	{
		var _=this;
		_.setOptions(options);
		
		// First time: when the page loads via http request
		window.addEvent('started', function(){
			var initialPlace = window.location.pathname.replace(/^\//, '').replace(/^/,'').replace(/\//,'_');
			if(initialPlace == '')
			{
				initialPlace = 'default';
			}
			_.onPageLoaded(initialPlace);
		});
		
		// Every other time: when pages change via ajax request
		window.addEvent('pageloaded', function(place){
			_.onPageLoaded(place);
		});
	},
	
	onPageLoaded: function(place)
	{
		var _=this, o=_.options;
		
		_.log.debug('anyPage ('+o.place+'): '+place);
		_.anyPage(place);
		
		if(place.test(o.place)){
			_.log.info('thisPage: '+o.place);
			_.thisPage(place);
		} else {
			_.log.info('otherPage ('+o.place+'): '+place);
			_.otherPage(place);
		}
	},
	
	thisPage: function(place, initial){},
	anyPage: function(place){},
	otherPage: function(place){}
		
});

