if (!Pages.Abstract) throw "Requires: [Pages.Abstract]";

Pages.Rates.Voucher = new Class({
	
	Extends: Pages.Abstract,
	
	val: 10,
	
	options: {
		place: '^rates_vouchers'
	},
	
	thisPage: function(place){
		this.initWidget();
	},
	
	initWidget: function()
	{
		var _ = this;
		$('Vouchers').addEvent('keyup:relay(.v-quantity)', function(e){
			_.updatePrice(e);
		});
		
//		$('Vouchers').addEvent("click:relay(input[type=checkbox])", function(e){
//				var row = e.target.getParent('tr');
//				row.getElements('.v-quantity')[0].readOnly = !e.target.checked;
//			if(!e.target.checked){
//				row.getElements('.v-quantity')[0].set('value','');
//			}
//		});
		
		$('PayPal-Submit').addEvent('click', function(e){
			_.submitForm();
			return false;
		});
	},
	
	updatePrice: function(e)
	{		
		var input = e.target;
		
		var quantity = input.get('value');
		if(isNaN(quantity))
		{
			quantity = 0;
		}
		var tr = input.getParent('tr');
		var unitPrice = tr.getElements('.price-unit')[0].get('text').replace(/,/g, '');
		
		var totalPrice = quantity * unitPrice;

        var totalPriceFormatted = totalPrice.format({
            decimal: ".",
            group: ",",
            decimals: 0
        });

		tr.getElements('.price-total').set('text', totalPriceFormatted);
		
		this.updateTotal(e);
	},
	
	updateTotal: function(e)
	{
		var total = 0;
		var table = e.target.getParent('table');

        var rows = table.getElements('tr').filter(function(row){
           return row.get('class') != 'grand-total';
        });

        rows.each(function(element){
            var totalString = element.getElement('.price-total').get('text');
            var subTotal = totalString.replace(/,/g, '').toFloat();
            total += subTotal;
		});

        var totalFormatted = total.format({
            decimal: ".",
            group: ",",
            decimals: 0
        });

		table.getElement('.v-Total').getElement('span').set('text', totalFormatted);
	},
	
	createURL: function()
	{
		var url = "/rates/vouchers/checkout?";
		var urlStr = "";
		var table = $('Vouchers').getElements('table')[0];
		table.getElements('tr').each(function(element){
					var qtyField = element.getElements('input[type=text]')[0];
					if(qtyField)
					{
						var value = qtyField.get('value');
						
						if(value > 0)
						{
							var key = qtyField.get('name');
							var val = key + '=' + value;
							urlStr += urlStr.length == 0 ? urlStr + val : '&' + val;
						}
					}
					
		});
		
		var detailsTable = $('Vouchers').getElements('table')[1];
		detailsTable.getElements('input').each(function(el){
			var value = el.get('value');
			var key = el.get('name');
			var val = key + '=' + value;
			
			urlStr += urlStr.length == 0 ? urlStr + val : '&' + val;
		});
		
		if(urlStr.length > 0)
		{
			url += urlStr;
		}else
			url = "";
		
		return url;
	},
	
	submitForm: function()
	{
		var URL = this.createURL();
		if(URL.length > 0)
		{
			$('Busy-top').fade('in');
			new Request.HTML({ url: URL,
				onComplete: function (responseTree, responseElements, responseHTML, responseJavaScript) {
					$('Busy-top').fade('out');
					if(responseHTML.indexOf('[') == 0)
					{
						alert(responseHTML);
					}
					else if(responseHTML.indexOf('INVALID_') == 0)
					{
						$json_str = responseHTML.substring(('INVALID_').length);
						var errors = JSON.decode($json_str);
						errors.each(function(error){
							var id = error[0]+"_invalid";
							$(id).set('text', error[1]);
						});
					}
					else
						window.location = responseHTML;
				}
			}).send();
		}		
	}
});

Pages.Rates.voucher = new Pages.Rates.Voucher();
