if (!Pages.Abstract) throw "Requires: [Pages.Abstract]";
/**
 * Pages.Rates
 * 
 * @package 	Pages
 * @depends		Pages.Abstract
 */
Pages.Rates = new Class({
	
	Extends: Pages.Abstract,
	
	options: {
		place: '^rates'
	},
	
	widget: null,
	currencyID: 'Rates-currency',
	currencies: {},
	
	/**
	 * It's up to each page to know if it's been initialised or not.
	 * You must come up with a test so as to avoid reinitialisation.
	 * @param place
	 */
	thisPage: function(place){
		
		var isVoucherPage = (place == 'rates_vouchers');
		
		this.showRatesCurrencyDropdown(isVoucherPage);
		if(!isVoucherPage)
		{
			this.initWidget();
		}	
		
	},
	
	showRatesCurrencyDropdown: function(isVoucherPage)
	{
		$(this.currencyID).setStyle('display', isVoucherPage ? 'none' : 'block');
		$$('.toolbar form')[0].setStyle('padding-right', isVoucherPage ? '0px' : '15px');
	},
	
	initWidget: function()
	{
		var _ = this;	
		_.widget = $(_.currencyID);
		var button = _.widget.getElement('button');
		
		$alt_curr = $('alternateCurr') == null ? 'EUR' : $('alternateCurr').get('text');

		// Make sure it's not already initialised.
		if (!!_.widget.retrieve('initialised')){
		
			var initialCode = Cookie.read('currency') || $alt_curr;
			button.fireEvent('change', initialCode);
			
			return;
		};
		
		_.widget.store('initialised', true);
		
		// Fix IE's Z-index
		if(Browser.Engine.trident){
			var zIndexNumber = 1000;
			// Put your target element(s) in the selector below!
			$$('#Rates div').each(function(el,i){
				el.setStyle('z-index',zIndexNumber);
				zIndexNumber -= 10;
	       });
		};

		var dropdown = _.widget.getElement('div');
		var links = _.widget.getElements('span');
		
		button.addEvent('click', function(){
			dropdown.setStyle('display', (
					dropdown.getStyle('display') === 'none' ? 'block' : 'none'));
		});
		
		links.each(function(span){
			_.currencies[span.get('data-code')] = span.get('data-euro');
		});
		
		links.addEvent('click', function(e){
			dropdown.setStyle('display', 'none');
			var span = e.target;
			var code = span.get('data-code');
			if (button.get('text') !== code){
				Cookie.write('currency', code);
				button.fireEvent('change', code);
			}
		});
				
		button.addEvent('change', function(code){
			button.set('text', code);
			$('r-currency').set('value', code);
			_.onCurrencyChanged(code);
		});
		
		$alt_curr = $('alternateCurr') == null ? 'EUR' : $('alternateCurr').get('text');
		var initialCode = Cookie.read('currency') || $alt_curr;
		
		button.fireEvent('change', initialCode);
	},
	
	onCurrencyChanged: function(code)
	{
		var _ = this;
		
		if ($('defaultCurr') != null && code === $('defaultCurr').get('text'))
		{
			var tables = document.getElements('.HasRates');
			var cells4 = tables.getElements('.cell4');

			cells4.each(function(el){
				el.getElement('.price-currency').set('text', '');
				el.getElement('.price-converted').set('text', '');
			});
		}
		else
		{
			var targets = [];
			document.getElements('.HasRates').each(function(table){
				table.getElements('.price-euro').each(function(span){
					targets.push(span);
				});
			});
			
			targets.each(function(priceEuro)
			{
				var rate = _.currencies[code];
				var basePrice = priceEuro.get('text').replace(',', '');
				
				var result = basePrice * rate;
				result = result.format({
				    decimal: ".",
				    group: ",",
				    decimals: 2
				});
				
				var row = priceEuro.getParent('tr');
				row.getElement('.price-currency').set('text', code);
				row.getElement('.price-converted').set('text', result);
			});
		}
	}
		
});

Pages.rates = new Pages.Rates();
