<?php defined('SYSPATH') or die('No direct script access.');
/**
 * Contains methods useful to all widgets
 *
 * @package    Synapse
 * @category   Kostache
 * @author     Synapse Studios
 */
abstract class Abstract_View_Administrator extends Abstract_View_Layout {

	protected $_layout = 'layout/administrator';
	
	public function assets($assets)
	{
		$assets->group('administrator');
		return parent::assets($assets);
	}
	
	public function js_array()
	{
		return array(
				'base_url'    => URL::base(),
				//'environment' => Kohana::$environment_string,
				'environment' => '',
				//'media_url'   => Media::url('/'),
				'media_url' => '',
		);
	}
	
	public function js_export()
	{
		return json_encode($this->js_array());
	}
	
	public function i18n()
	{
		return function($string)
		{
			return __($string);
		};
	}
	
	public function title()
	{
		return __($this->title);
	}
	
	public function profiler()
	{
		return View::factory('profiler/stats');
	}
	
	public function assets_head()
	{
		if ( ! $this->_assets)
			return '';
	
		$assets = '';
		foreach ($this->_assets->get('head') as $asset)
		{
			$assets .= $asset."\n";
		}
	
		return $assets;
	}
	
	public function assets_body()
	{
		if ( ! $this->_assets)
			return '';
	
		$assets = '';
		foreach ($this->_assets->get('body') as $asset)
		{
			$assets .= $asset;
		}
	
		return $assets;
	}
	
	public function render($template = null, $view = null, $partials = null)
	{
		$content = parent::render($template, $view, $partials);
	
		return str_replace(array
				(
						'[[messages]]',
						'[[assets_head]]',
						'[[assets_body]]',
						'</form>',
				), array
				(
						Message::output(),
						$this->assets_head(),
						$this->assets_body(),
						"\t".'<input type=hidden name=csrf-token value="'.CSRF::token().'" />'."\n\t\t".'</form>',
				), $content);
	}
}