<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Admin_Blog extends Abstract_Controller_Page {
	
	protected $controller_requires_roles = array('login');
	
	
	public function before()
	{
		parent::before();
	}
	
	public function show()
	{
		$id = $this->request->param('id');
		$url_amp = urlencode('&');
		$this->_view->id = $id;
		$this->_view->admin_blog_css = str_replace('&', $url_amp, MinifyUtil::instance()->group('admin_blog_css'));
		$this->_view->admin_blog_js  = str_replace('&', $url_amp, MinifyUtil::instance()->group('admin_blog_js'));
		$this->edit_item($id);
		
		$this->_view->menu_items = $this->menu_items();
		$this->_view->has_items = count($this->_view->menu_items) > 0;
	}
	
	public function action_index()
	{
			$this->show();
	}
	
	public function action_edit()
	{
		if($_POST)
		{
			$this->save();
		}else{
			$this->show();
		}
	}
	
	public function action_delete()
	{
        $controller = 'blog';
		$id = $this->request->param('id');
		$this->delete($id, 'blogpost', $controller);
	}
	
	public function save()
	{
		if($this->is_valid($_POST))
		{
			$subtitle = trim($_POST['node_options_code']);

			if (empty($subtitle))
			{
				$subtitle = $_POST['node_core_name'];
			}

			$_POST['node_options_code'] = $this->get_code($subtitle);
            $_POST['node_options_date'] = time();
			$this->save_node('blog', 'blogpost');
		}
	}
	
	public function get_code($subtitle)
	{	
		return URL::title($subtitle);
	}
	
	public function is_valid($data)
	{
		return TRUE;
	}
	
	public function edit_item($id)
	{
			$node = Node::factory('blogpost', NULL, array('author', 'date', 'code'))
			->and_where('node_id', '=', $id)
			->find();
			$this->_view->node = $node;
			$this->_view->text = $node->blogpost->text;
			$this->_view->selected = $node->status;
	}
	
	public function menu_items()
	{
		$menu_items = array();
		$items = Node::factory('blogpost', NULL, array('author', 'date', 'code'))
		->order_by_option('date', 'DESC')
		->find_all();
		
		foreach ($items as $item)
		{
			$href = '/administrator/blog/edit/'.$item->id;
			$date = $item->option('date');
			$display_date = isset($date) ? Date::fuzzy_span($date) : '';
			$text = $item->name;

			$menu_items[] = array(
					'href'	=> $href,
					'text' 	=> $text,
					'date'  => $display_date,
					'author' => $item->option('author'),
					'code' => $item->option('code'),
					'status' => $item->status,
			);
		}
		return $menu_items;
	}
	
	
	public function execute()
	{
		$response = $this->response;
		return $response;
	}
	
}