<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Admin_Gallery extends Abstract_Controller_Page {
	
	protected $controller_requires_roles = array('login');
	
	
	public function before()
	{
		parent::before();
	}
	
	public function action_index()
	{
		$nodes = Node::factory('gallery', NULL, array('name', 'date', 'code', 'type'))
			->find_all();
		
		$data = array();
		
		$has_data = FALSE;
		
		foreach ($nodes as $node){
			$has_data = TRUE;
			$gallery = $node->gallery;
			$row = array(
					'name' => $node->name,
					'code' => $gallery->code,
					'type' => $this->convert_type($gallery->type),
					'date' => $gallery->date,
					'href' => '/administrator/gallery/edit/'.$gallery->node_id,
					);
			
			$data[] = $row;
		}

		$this->_view->has_data = $has_data;
		$this->_view->data = $data;
	}
	
	public function convert_type($type)
	{
		switch ($type)
		{
			case 'P' :
				return 'Photo';
			case 'Y' : 
				return 'Video';
			default:
				return 'Photo';
		}
	}
	
	public function action_edit()
	{
		$id = $this->request->param('id');
		
		if($_POST)
		{
			$this->save_node('gallery', 'gallery');
		}
		else if(!is_null($id))
		{
			$node = Node::factory('gallery', NULL, array('name', 'date', 'code', 'type'))
			->and_where('node_id', '=', $id)
			->find();
			
			$this->_view->id = $id;
			$this->_view->node = $node;
			$this->_view->selected = $node->gallery->type;
		}
	}
	
	public function action_delete()
	{
		$id = $this->request->param('id');
		$this->delete($id, 'gallery','gallery');
	}
	
	public function execute()
	{
		$response = $this->response;
		return $response;
	}
	
}