<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Admin_Vouchers extends Abstract_Controller_Page {
	
	protected $controller_requires_roles = array('login');

	public function action_index()
	{
		$code = NULL;
		
		if(isset($_GET['code']))
		{
			$code = $_GET['code'];
		}
		$this->_view->vouchers = $this->get_files($code);		
	}
	
	
	public function get_files($code = NULL)
	{
		$files = array();
		$vouchers_dir = APPPATH.'../../../vouchers';
		if(realpath($vouchers_dir) === FALSE)
		{
			return $files;
		}
		if ($handle = opendir($vouchers_dir)) {
			while (false !== ($entry = readdir($handle))) {
				if($this->EndsWith($entry, '.pdf'))
				{
					$token = str_replace('.pdf', '', str_replace('aquaventures-voucher_', '', $entry));
					if($code != NULL)
					{
						if($this->BeginsWith($token, $code))
						{
							$files[] = array(
									'name' => $entry,
									'code' => $token,
									'time' => date ("F d Y H:i:s", filemtime($vouchers_dir.DIRECTORY_SEPARATOR.$entry)),
							);
						}
					}else
					{
						$files[] = array(
								'name' => $entry,
								'code' => $token,
								'time' => date ("F d Y H:i:s", filemtime($vouchers_dir.DIRECTORY_SEPARATOR.$entry)),
						);
					}
				}
			}
			
			
				closedir($handle);
		}
		
		$times = array();
		
		foreach ($files as $key => $row)
		{
			$times[$key] = $row['time'];
		}
		
		array_multisort($times, SORT_DESC, $files);
		
		return $files;
	}
	
	public function execute()
	{
		$response = $this->response;
		return $response;
	}
	
	
	function EndsWith($Haystack, $Needle){
		return strrpos($Haystack, $Needle) === strlen($Haystack)-strlen($Needle);
	}
	
	function BeginsWith( $str, $sub ) {
		return ( substr( $str, 0, strlen( $sub ) ) == $sub );
	}
}