<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Email_Voucher extends Controller {

	public $template = 'email/voucher';
	public $subtitle = 'Aqua Ventures Voucher';
	
	protected $_view;
	
	
	public function before(){
		parent::before();
		$file = $this->template;
		$this->template = View::factory($file);
	}
	
	public function action_index()
	{
			if(isset($_POST))
			{
				$converter = Converter::instance();
				$this->template->token = $_SESSION['TOKEN'];
				
				$this->template->user_details = $_SESSION['USER_DETAILS'];
				
				$this->template->user_items = $converter->get_table_data($_SESSION['USER_ITEMS']);
				
				$symbol = $converter->currency_symbol();
				$this->template->total = $symbol.$converter->calculate_total($_SESSION['USER_ITEMS']);
				
				$this->template->download_url = URL::base() . 'downloads/voucher/'.$_SESSION['TOKEN'];
				
				if(isset($_POST['is_admin'])){
					$this->template->is_admin = TRUE;
				}
			}
	}
	
	
	public function get_user_array($post,$suffix)
	{
		$items = array();
		foreach ($post as $key => $value)
		{
			$pos = strrpos($key, $suffix);
			if($pos && $value)
			{
				$key = substr($key, 0, $pos);
				$items[$key] = $value;
			}
		}
		return $items;
	}

	
	public function after(){	
		$view = $this->template;
		$this->response->body($view);
		parent::after();
	}
}
