<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Error extends Controller{

	public $template = 'template/errors';

	public $msg404 = '<h1>Sorry, that page could not be found.</h1>';

	public $msg500 = '<h1>Oops, the server encountered an error.</h1>';

	public function before()
	{
		parent::before();
		$file = $this->template;
		// only load the template if the template has not been set..
		$this->template = View::factory($file);
		// Initialize empty values
		// Page title
		$this->template->title = '';
		// Page content
		$this->template->content = '';
		// Styles in header
		$this->template->styles = array();
		// Scripts in header
		$this->template->scripts = array();
		// DirectoryName will contain the name of the Controller in the Template
		$this->template->directory_name = $this->request->directory();

		$this->template->website = Website::instance(); //Kohana::$config->load('website');
		// next, it is expected that $this->template->content is set e.g. by rendering a view into it.
		$this->template->file = $file;
	}

	public function after()
	{
		parent::after();
		$styles = array();
		$scripts = array();
		$this->template->styles = array_merge($this->template->styles, $styles);
		$this->template->scripts = array_merge($this->template->scripts, $scripts);


		// Display profile if its enabled and request by query profile
		$this->template->profile = (isset($_REQUEST['profile']) && Kohana::$profiling)?"<div id=\"kohana-profiler\">".View::factory('profiler/stats')."</div>":"";
		// Assign the template as the request response and render it
		$this->response->body($this->template);
	}

	public function action_index()
	{

	}

	public function action_404()
	{
		$this->template->content = $this->msg404;
	}

	public function action_500()
	{
		$this->template->content = $this->msg500;
	}
}
