<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Pages_Rates extends Controller_Hijax implements HasMenu {

	public $template = 'pages/rates';
	
	public function action_index()
	{
		$this->template->default_currency = Converter::instance()->default_currency();
		$this->template->price_currency = Converter::instance()->price_currency();
		
		$this->template->menu = Menu::factory($this);
		$this->template->content = $this->subrequest('pages_rates', 1);	
		
		// Get rates as a subrequest from the currency controller
		$rates = (array) json_decode(Request::factory('currency/list')->execute());
		$this->template->default_currency = Kohana::$config->load('currency.default');
		$this->template->alternate_currency = Kohana::$config->load('currency.alternate_currency');
		$this->template->currencies = Kohana::$config->load('currency.currencies');
		$this->template->rates = $rates;
	}
	
	public function menu_data($identifier)
	{
		$menu[] = array('Rates-menu-divepackages', 	'Dive Packages', 'diving');
		$menu[] = array('Rates-menu-padicourses',  	'PADI Courses',  'padi');
		$menu[] = array('Rates-menu-bsaccourses',  	'BSAC Courses',  'bsac');
		$menu[] = array('Rates-menu-equipment',  	'Equipment hire',  	 'equipment');
//		$menu[] = array('Rates-menu-buyvouchers', 	'Buy Vouchers',  'vouchers');
		$menu[] = array('Rates-menu-flights', 		'Flights', 		 'flights');
		$menu[] = array('Rates-menu-accommodation', 'Accommodation', 'accommodation');
		return $menu;
	}
	
	public function menu_item($item, $identifier)
	{
		return array(
			'id' 	=> $item[0],
			'text' 	=> $item[1],
			'href'	=> '/rates/'.$item[2],
			'class' => 'Rates-menu-item',
		);
	}
	
	public function is_active($item, $current, $identifier)
	{
		return $current === $item['href'];
	}
	
	protected function subrequest($path, $level)
	{
		if ($this->is_ajax())
		{
			$subrequest = $this->get_subrequest();
		}
		else
		{
			$subrequest = Request::initial()->param('level'.$level);
		}
	
		if (!empty($subrequest))
		{
			$subrequest_url = $path.'_'.$subrequest;
		}
		else
		{
			$subrequest_url = $path.'_diving';
			// 			$subrequest_url = $path.'_default';
		}
	
		return Request::factory( $subrequest_url )->execute();
	}
	
}
