<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Pages_Rates_Vouchers extends Controller_Hijax {

	public $template = 'pages/rates/vouchers';
	public $subtitle = 'Gift Vouchers';
	
	protected $paymentAmount = 0;
	

	//' are set to the selections made on the Integration Assistant
	//'------------------------------------
	protected $paymentType = "Sale";
	
	//'------------------------------------
	//' The returnURL is the location where buyers return to when a
	//' payment has been succesfully authorized.
	//'
	//' This is set to the value entered on the Integration Assistant
	//'------------------------------------
	protected $returnURL = "rates/vouchers/return/";
	
	//'------------------------------------
	//' The cancelURL is the location buyers are sent to when they hit the
	//' cancel button during authorization of payment during the PayPal flow
	//'
	//' This is set to the value entered on the Integration Assistant
	//'------------------------------------
	protected $cancelURL = "rates/vouchers/cancel/";
	
	protected $names = array('first_name', 'last_name', 'email', 'phone', 'country');

	
	public function action_return()
	{
		if(isset($_GET['token']) && isset($_SESSION['TOKEN']))
		{
			$token = $_GET['token'];
			
			$session_token = $_SESSION['TOKEN'];
			
			if($token === $session_token)
			{
				$this->create_voucher();

				$this->email_voucher();
			}
		}
		
		//REDIRECT
		$_SESSION['paypal_return'] = true;
		header("Location: /rates/vouchers");
		exit;
	}
	
	public function get_report_url()
	{
		$url = 'http://localhost/reports/voucher';
		$session_token = $_SESSION['TOKEN'];
		
		$url .= ' --post token '.$session_token;
		
		$user_items = $_SESSION['USER_ITEMS'];		
		
		foreach ($user_items as $key => $value)
		{
			$url .= ' --post '.$key.'_uitem'.' '.$value;
		}
			
		$user_details = $_SESSION['USER_DETAILS'];
		
		foreach ($user_details as $key => $value)
		{
			$url .= ' --post '.$key.'_udetail'.' '.$value;
		}
		return $url;
	}
	
//	public function create_voucher()
//	{
////		$url = $this->get_report_url();
////		
////		if(isset($_SESSION['TOKEN']))
////		{
////			$voucher_dir = APPPATH.'../../../vouchers';
////			if(realpath($voucher_dir) == FALSE)
////			{
////				mkdir($voucher_dir);
////			}
////
////			$file = realpath($voucher_dir).'/aquaventures-voucher_'.$_SESSION['TOKEN'].'.pdf';
////			$wkhtml = APPPATH.'vendor/webkit/wkhtmltopdf-i386';
////			$command = "$wkhtml $url $file --ignore-load-errors";
////			`$command`;
////		}
//	}

	protected function create_voucher()
	{
		if(isset($_SESSION['TOKEN']))
		{
			require_once(APPPATH.'vendor/tcpdf/config/lang/eng.php');
			$pdf = Pdf::factory('voucher');
			
			// set default monospaced font
			$pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);
			
			//set margins
			$pdf->SetMargins(PDF_MARGIN_LEFT, PDF_MARGIN_TOP, PDF_MARGIN_RIGHT);
			$pdf->SetHeaderMargin(PDF_MARGIN_HEADER);
			$pdf->SetFooterMargin(PDF_MARGIN_FOOTER);
			
			//set auto page breaks
			$pdf->SetAutoPageBreak(TRUE, PDF_MARGIN_BOTTOM);
			
			//set image scale factor
			$pdf->setImageScale(PDF_IMAGE_SCALE_RATIO);
			
			//set some language-dependent strings
			$pdf->setLanguageArray($l);
	
			// set font
			$pdf->SetFont('helvetica', '', 10);
			
			$user_items = $_SESSION['USER_ITEMS'];
			

			foreach ($user_items as $key => $value)
			{
				for($i = 0; $i < $value; $i++)
				{
					$name = Converter::instance()->get_name_from_lists($key);
					$pdf->AddPage();
					$y = $pdf->getY();
					$pdf->SetY($y + 20);
					$html = $this->get_voucher_html($name);
					$pdf->writeHTML($html, true, false, true, false, '');
				}
			}
			
			$voucher_dir = APPPATH.'../../../vouchers';
			if(realpath($voucher_dir) == FALSE)
			{
				mkdir($voucher_dir);
			}

			$file = realpath($voucher_dir).'/aquaventures-voucher_'.$_SESSION['TOKEN'].'.pdf';
	
			//Close and output PDF document
			$pdf->Output($file, 'F');
		}
	}
	
	protected function get_voucher_html($item)
	{	
		$token = $_SESSION['TOKEN'];
		
		$legal_url = URL::base().'voucher/terms';
			
		$user_details = $_SESSION['USER_DETAILS'];
		
		$html = '<table>
				<tr>
				<td>
						<h3 style="margin: 0px; padding: 0px;">Voucher</h3>
						<ul style="list-style-type: none;padding:0px;margin:0px;">
							<li>'.$item.'</li>
						</ul>
				</td>
				<td style="padding-left: 100px;">
					<table>
						<tr>
							<td style="border-bottom: 1px dashed black; line-height: 5px;">
								Code: <span>'.$token.'</span>
							</td>
						</tr>
						<tr>
							<td style="border-bottom: 1px dashed black; line-height: 5px;">
								Purchased by: <span>'.$user_details['first_name'].'</span> <span>'.$user_details['last_name'].'</span>
							</td>
						</tr>
						<tr>
							<td style="border-bottom: 1px dashed black; line-height: 5px;">
								E-Mail: <span>'.$user_details['email'].'</span>
							</td>
						</tr>
						<tr>
							<td style="border-bottom: 1px dashed black; line-height: 5px;">
								Phone Number: <span>'.$user_details['phone'].'</span>
							</td>
						</tr>
						<tr>
							<td style="border-bottom: 1px dashed black; line-height: 5px;">
								Presented to:
							</td>
						</tr>
						<tr>
							<td style="border-bottom: 1px dashed black; line-height: 5px;">
								&nbsp;
							</td>
						</tr>
						<tr>
							<td style="border-bottom: 1px dashed black; line-height: 5px;">
								&nbsp;
							</td>
						</tr>
					</table>
				</td>
				</tr>
				<tr>
					<td>			
					 <table style="font-size: .75em;width: 90%;">
						<tr>
								<td style="padding-right: 0.5cm;">
									P.O. Box 275
									Watamu Kenya
									80202
								</td>
								<td>
									+254 42 233 2420
									<a href="http://www.diveinkenya.com">http://www.diveinkenya.com</a>
								</td>
							</tr>
					 </table>
					</td>
					<td><a href="'.$legal_url.'">'.$legal_url.'</a></td>
				</tr>
			</table>';
		
		return $html;
	}
	
	public function email_voucher()
	{
		try{
			$page =  Request::factory( 'email_voucher' )->execute();
			$to = $_SESSION['USER_DETAILS']['email'];
			$from = Kohana::$config->load('email.company.email');
			Email::send($to, $from, 'Aqua Ventures Voucher', $page, TRUE);
			
			$_GET['is_admin'] = TRUE;
			$page =  Request::factory( 'email_voucher' )->execute();

			Email::send($from, $from, 'Aqua Ventures Voucher '.$_SESSION['TOKEN'], $page, TRUE);
		}catch (HTTP_Exception_404 $e){}
	}
	
	public function action_cancel()
	{
		//REDIRECT
		$_SESSION['paypal_cancel'] = true;
		header("Location: /rates/vouchers");
		exit;
	}

	public function action_checkout()
	{
		$this->auto_render = FALSE;
		
		$user_details = $this->get_user_details();
		if($this->is_valid($user_details)){
			if($this->process_checkout())
			{
				$_SESSION['USER_DETAILS'] = $user_details;
			}
		}
	}
	
	public function action_index()
	{
		
		if(isset($_SESSION['paypal_return']) && $_SESSION['paypal_return'] == TRUE && isset($_SESSION['TOKEN']))
		{
			$this->template->download_url = URL::base(). 'downloads/voucher/'.$_SESSION['TOKEN'];
			$this->template->paypal_return = TRUE;
			$this->unset_checkout_details();	
		}
		else if(isset($_SESSION['paypal_cancel']) && $_SESSION['paypal_cancel'] == TRUE && isset($_SESSION['TOKEN']))
		{
			$this->template->paypal_cancel = TRUE;
			$this->unset_checkout_details();
		}
		else{
			$this->template->prices = 	Converter::instance()->get_prices(NULL);
			$this->template->list = 	Converter::instance()->get_list(TRUE);
			$this->template->curr_symbol = Converter::instance()->currency_symbol();
			$this->template->info = '<p>Purchase vouchers for you, family and friends</p>';
		}
	}
	
	function unset_checkout_details()
	{
		unset($_SESSION['TOKEN']);
		unset($_SESSION['USER_ITEMS']);
		unset($_SESSION['USER_DETAILS']);
		unset($_SESSION['paypal_return']);
		unset($_SESSION['paypal_cancel']);
	}
	
	
	function is_valid($user_details)
	{
		$is_valid = TRUE;
		
		if(isset($user_details) == FALSE)
		{
			return FALSE;
		}
		
		$resp = array();
		$first_name =	$user_details['first_name'];
		$last_name  =	$user_details['last_name'];
		$email 		=	$user_details['email'];
		
		if(strlen($first_name) == 0)
		{
			$resp[] = array('first_name','required');
			$is_valid = FALSE;
		}
		
		if(strlen($last_name) == 0)
		{
			$resp[] = array('last_name','required');
			$is_valid = FALSE;
		}
		
		if(strlen($email) == 0)
		{
			$resp[] = array('email','required');
			$is_valid = FALSE;
		}
		else if (filter_var($email, FILTER_VALIDATE_EMAIL) == FALSE) {
			$resp[] = array('email','Invalid Email');
			$is_valid = FALSE;
		}
		
		if($is_valid == FALSE)
		{
			echo 'INVALID_'.json_encode($resp);
		}
		
		return $is_valid;
	}
	
	function process_checkout()
	{
		$success = TRUE;
		$return_code = Text::random('alnum',12);
		$cancel_code = Text::random('alnum',12);
		
		$return_url = Kohana::$base_url.$this->returnURL . $return_code;
		$cancel_url = Kohana::$base_url.$this->cancelURL . $cancel_code;
		
		//TODO use this
		// 		$return_url = URL::base() . 'checkout/';
		// 		$cancel_url = URL::base() . 'checkout/';
		
		$_SESSION['RETURN_CODE'] = $return_code;
		$_SESSION['CANCEL_CODE'] = $cancel_code;
		
		//$currency_code = $_GET['currency_code'];
		$currency_code = Kohana::$config->load('currency.default');
		
		$items = $this->get_selected_items();
		$_SESSION['USER_ITEMS'] = $items;
		
		$nvpitemsstr = $this->get_nvp_items_str($items);
		
		$total = Converter::instance()->calculate_total($items);

		$_SESSION['Payment_Amount'] = $total;
		
		$resArray = CallShortcutExpressCheckout ($total, $currency_code, $this->paymentType, $return_url, $cancel_url, $nvpitemsstr);
		$ack = strtoupper($resArray["ACK"]);
		
		$resp = "";

		if($ack=="SUCCESS" || $ack=="SUCCESSWITHWARNING")
		{
			$resp = getPayPalRedirectURL($resArray['TOKEN']);
		}
		else
		{
			$success = FALSE;
			//Display a user friendly Error on the page using any of the following error information returned by PayPal
			$ErrorCode = urldecode($resArray["L_ERRORCODE0"]);
			$ErrorShortMsg = urldecode($resArray["L_SHORTMESSAGE0"]);
			$ErrorLongMsg = urldecode($resArray["L_LONGMESSAGE0"]);
			$ErrorSeverityCode = urldecode($resArray["L_SEVERITYCODE0"]);
	
			$resp  = '[SetExpressCheckout API call failed. ';
			$resp .= 'Detailed Error Message: ' . $ErrorLongMsg;
			$resp .= 'Short Error Message: ' . $ErrorShortMsg;
			$resp .= 'Error Code: ' . $ErrorCode;
			$resp .= 'Error Severity Code: ' . $ErrorSeverityCode;
			$resp .= ']';
		}
		echo $resp;
		return $success;
	}
	
	function get_user_details()
	{
		
		
		$items = array();
		foreach ($_GET as $key => $value)
		{
			$has_name = in_array($key, $this->names);
			if($has_name)
				{
					$items[$key] = $value;
				}
			}
		return $items;
	}
	
	function get_selected_items()
	{
		$items = array();
		foreach ($_GET as $key => $value)
		{
			$pos = strrpos($key, "_quantity");
			
			if($pos && $value && $value > 0)
			{
				$key = substr($key, 0, $pos);
				$items[$key] = $value;
			}
		}
		return $items;
	}
	
	function get_nvp_items_str($items)
	{
		$nvpitemsstr = "";
		$prices  = Converter::instance()->get_prices();
		$i = 0;
		foreach ($items as $key => $value )
		{
			$amount = $prices[$key] * $value;
			$nvpitemsstr .= '&L_PAYMENTREQUEST_0_NAME'.$i.'=' . Converter::instance()->get_name_from_lists($key);
			$nvpitemsstr .= '&L_PAYMENTREQUEST_0_AMT'.$i.'=' . $amount;
	
			$i++;
		}
		return $nvpitemsstr;
	}
}
