<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Pages_Reports_Prices extends Controller {

	public $template = 'pages/reports/prices';
	public $subtitle = 'Aqua Ventures Rates';
	
	protected $_view;
	
	public $rate = 1;
	
	public function before(){
		parent::before();
		$file = $this->template;
		$this->template = View::factory($file);
	}
	
	public function action_index()
	{
		$curr = Kohana::$config->load('currency.default');
		$default_currency = $curr;
		$symbols = Kohana::$config->load('currency.symbols');
		$this->template->default_symbol = $symbols[$curr];
		
		if(isset($_GET['currency'])){
			$curr = $_GET['currency'];
		}
		
		if($curr == $default_currency){
			$curr = 'KES';
		}

		$price_currency = Kohana::$config->load('currency.price_currency');
		
		
		$this->template->curr_symbol = $symbols[$curr];
		
		$this->set_rate($curr);
		
		$this->template->diving_prices = $this->convert_prices(Kohana::$config->load('rates.diving_prices'));
		$this->template->diving_list = Kohana::$config->load('rates.diving_list');
		
		$this->template->diving_packages_prices = $this->convert_prices(Kohana::$config->load('rates.diving_packages_prices'));
		$this->template->diving_packages_list = Kohana::$config->load('rates.diving_packages_list');
		
        $this->template->surcharge = Kohana::$config->load('rates.messages.surcharge');

		$this->template->padi_prices = $this->convert_prices(Kohana::$config->load('rates.padi_prices'));
		$this->template->padi_list = Kohana::$config->load('rates.padi_list');
		
		$this->template->bsac_prices = $this->convert_prices(Kohana::$config->load('rates.bsac_prices'));
		$this->template->bsac_list = Kohana::$config->load('rates.bsac_list');

		$this->template->equipment_prices = $this->convert_prices(Kohana::$config->load('rates.equipment_prices'));
		$this->template->equipment_list = Kohana::$config->load('rates.equipment_list');

	}
	
	public function after(){	
		$view = $this->template;
		$this->response->body($view);
		parent::after();
	}
	
	function set_rate($curr){
		$price_currency = Kohana::$config->load('currency.price_currency');
		$currency_controller = new Kohana_Controller_Currency($this->request, $this->response);
	
		if($curr != $price_currency){
			$curr = $currency_controller->convert($curr, $price_currency);
			$this->rate = $curr['rate'];
		}
	}
	
	function convert_prices($prices){
		foreach ($prices as $key => $value)
		{
			$prices[$key] = array($value,$this->convert_value($value));
		}
		return $prices;
	}
	
	function convert_value($value){
		$value = $value / $this->rate;
		return number_format($value, 2, '.', '');
	}
}
