<?php defined('SYSPATH') or die('No direct script access.');
/**
 * HasMenu interface that is implemeneted by Controllers that want a convenient 
 * way to render a menu including "active" highlighting for CSS.
 */
interface HasMenu {
	
	/**
	 * Provide the items for the menu.
	 *  
	 * @param string $identifier an abitrary string of your choice to distinguish
	 * between multiple Menu instances in the same controller
	 * @return array
	 */
	public function menu_data($identifier);

	/**
	 * Create a menu item array based on the $item.
	 * 
	 * @param object $item
	 * @param string $identifier an abitrary string of your choice to distinguish
	 * between multiple Menu instances in the same controller
	 * @return array
	 */
	public function menu_item($item, $identifier);
	
	/**
	 * Implement this and return true or false whether this $item is currently active.
	 * 
	 * @param array $item menu item
	 * @param string $current current URI
	 * @param string $identifier an abitrary string of your choice to distinguish
	 * between multiple Menu instances in the same controller
	 * @return boolean
	 */
	public function is_active($item, $current, $identifier);

}