<?php

class Repositories extends Arden_Repositories {

	public static function add($key, $repository = NULL)
	{
		if (is_null($repository))
		{
			foreach ((array) $key as $type)
			{
				static::$_repositories[$type] = self::initialize($type);
			}
		}
		else
		{
			parent::add($key, $repository);
		}
	}

	protected static function initialize($type)
	{
		$singular = Inflector::singular($type);
		$capitalized = Inflector::underscore(ucwords(Inflector::humanize($singular)));
		$class_name = 'Repository_Kohanadatabase_'.$capitalized;
		$model_name = 'Model_'.$capitalized;

		return new $class_name(
			Database::instance(), // TODO accept database instances.
			new Database_Query_Builder_Select,
			new Database_Query_Builder_Insert,
			new Database_Query_Builder_Update,
			new Database_Query_Builder_Delete,
			$model_name,
			$type
		);
	}

}
