<?php defined( 'SYSPATH' ) or die( 'No direct script access.' );

class Website extends Kohana_Website{
	
	
	public static $gallery_link = NULL;
	/**
	 * Override this function to provide different markup for your menu item
	 * @param string $menu_item_key
	 * @param array $menu_item
	 */
	protected function mainmenu_item($menu_item_key, $menu_item)
	{
		
		$href = $menu_item['href'];
		if(preg_match("/^gallery/", $href))
		{
			$menu_item['href'] = $this->get_gallery_link($href);
		}
		
		$html = $menu_item['name'].' <em style=\'left:'.$menu_item['left'].'px;\'>'.$menu_item['desc'].'</em>';
		return HTML::anchor('/'.$menu_item['href'], $html);
	}
	
	private function get_gallery_link($href)
	{
		$uri =  'gallery/';

		$latest_node = $nodes = Node::factory('gallery', NULL, array('name', 'date', 'code', 'type'))
			->find_all();

		if(isset($latest_node[0]))
		{
			$node = $latest_node[0];

			$type = $node->gallery->type;
			$code = $type === 'Y' ? 'video' : 'photo';
			$code .= ':'.$node->gallery->code;
			$uri .= $code;
		}

		if(Website::$gallery_link !== $uri)
		{
			Website::$gallery_link = $uri;
		}
		
		return Website::$gallery_link;
	}
	
	protected function javascript_mainmenu()
	{
		$items = $this->config->get('mainmenu');
	
		$mainmenu = array();
	
		foreach($items as $key => $val)
		{
			if ($val['type'] === 'item')
			{
				$val['code'] = $key;	
				$href = $val['href'];	
				
				if(preg_match("/^gallery/", $href))
				{
					$val['href'] = $this->get_gallery_link($href);
				}
				$mainmenu[] = $val;
			}
		}
		$js_mainmenu = json_encode($mainmenu);
		$js_title = $this->config->get('title');
		$js_title_sep = $this->config->get('title_separator');
		$js_title_pos = $this->config->get('title_position');
		 
		return 'var Website=Website||{};'
				."Website.mainMenuItems=$js_mainmenu;"
				."Website.title='$js_title';"
				."Website.titleSeparator='$js_title_sep';"
				."Website.titlePosition='$js_title_pos';";
	}
}