<?php
/**
 * @package
 * @author      Paul Schwarz <paulsschwarz@gmail.com>
 * @copyright   2012 Paul Schwarz
 * Date         06/09/12 17:02
 */
class Panels{

    protected static $instance;

    protected $panels = array();

    /**
     * Singleton.
     * @static
     * @return Panels
     */
    public static function instance()
    {
        if (is_null(self::$instance))
        {
            self::$instance = new Panels();
        }

        return self::$instance;
    }

    public function render()
    {
        $menu = '';
        $html = '';

        $config = Kohana::$config->load('homepage');

        foreach ($config as $row)
        {
        	$key = $row[0];
        	$title = $row[1];
            $subtitle = $row[2];

        	$menu .= $this->create_menu_item($key, $title, $subtitle);
        	$html .= $this->create_panel($key);
        }

        return array($menu, $html);
    }

    function create_menu_item($id, $title, $subtitle)
    {
    	return "<a href=#$id data-hijack=no data-id=$id>$title<em>$subtitle</em></a>\n";
    }

    function create_panel($id)
    {
    	$path = realpath(APPPATH.'views/pages/home/panels/'.$id.'.html');
    	return file_get_contents($path);
    }

}

$content = Panels::instance()->render();
