<?php defined('SYSPATH') or die('No direct script access.');
/**
 * Request Client for internal execution
 *
 * @package    Kohana
 * @category   Base
 * @author     Kohana Team
 * @copyright  (c) 2008-2011 Kohana Team
 * @license    http://kohanaframework.org/license
 * @since      3.1.0
 */
class Hijax_Request_Client_Internal extends Kohana_Request_Client_Internal {

	public function execute_request(Request $request)
	{
		// Create the class prefix
		$prefix = 'controller_';
		
		// Directory
		$directory = $request->directory();
		
		// Controller
		$controller = $request->controller();
		
		if ($directory)
		{
			// Add the directory name to the class prefix
			$prefix .= str_replace(array('\\', '/'), '_', trim($directory, '/')).'_';
		}

		if ( ! class_exists($prefix.$controller))
		{
			return parent::execute_request($request);
		}
		else 
		{
			try
			{
				return parent::execute_request($request);
			}
			catch (HTTP_Exception_404 $e)
			{
				// Take the failed action and try it as an id instead
				$request->set_param('id', $request->action());
					
				// Set the action back to the route's default action
				$request->action(Arr::get($request->route()->defaults(), 'action'));
					
				return parent::execute_request($request);
			}
		}
	}
	
} // End Hijax_Request_Client_Internal
