<?php defined('SYSPATH') or die('No direct script access.');
	
class View_User_Login extends Kostache {
	
	public function render()
	{
		$form = new Appform();
		
		if(isset($this->errors)) {
			$form->errors = $this->errors;
		}
		
		if(isset($this->username)) {
			$form->values['username'] = $this->username;
		}
		
		// set custom classes to get labels moved to bottom:
		$form->error_class = 'error block';
		$form->info_class = 'info block';
		
		$this->set('username',
			$form->labelled_input('User name', 'username', NULL, array(
				'autofocus' => TRUE,
			)
		));
		
		$this->set('password',
			$form->labelled_password('Password', 'password'));
		
		$login = $form->submit(NULL, 'Log in', array(
			'style' => 'float: right',
			'class' => 'btn'
		));
		
		$auth_class = new ReflectionClass(get_class(Auth::instance()));
		if($auth_class->hasMethod('auto_login'))
		{
			$login = 
				$form->label('remember', __('Remember me')).
				$form->checkbox('remember', 'remember', FALSE, array(
					'id'=>'remember',
					'class' => 'control',
				)).
				$login;
		}
		$this->set('login', $login);
		
		$this->set('forgot', 
			Html::anchor('user/forgot', __('Forgot your password?')));
		
		if (Kohana::$config->load('user.registration'))
		{
			$this->set('register',
				__('Don\'t have an account?').' '
				.Html::anchor('user/register', __('Register a new account'))
			);
		}
		
		$providers = array_filter(Kohana::$config->load('user.providers'));

		foreach($providers as $provider => $enabled)
		{
			$this->set($provider,
				HTML::anchor(URL::site('/user/provider/'.$provider), '', array(
					'data-provider' => ucfirst($provider),
					'class' => 'login_provider',
					'style' => 'background: #fff url(/assets/mss-platform-user/img/'.$provider.'.png) no-repeat center center'
				))
			);
		}
		
		return parent::render();
	}
	
}
