<?php defined('SYSPATH') or die('No direct script access.');

abstract class Kohana_Controller_App_Template extends Kohana_Controller_App {
	
	public function action_index()
	{
		/*
		 * autofullsize stretches the wrapper to fill the main area.
		 * datatable gives the contained datatable a wrapper to fill up to.
		 */
		Template::instance($this)->render(array(
			'subtitle'	=> $this->subtitle(),
			'toolbar'	=> $this->toolbar('index'),
			'article'	=> '<div class="autofullsize datatable">'.new View_Data_DataTable($this->request, $this->fields()).'<div>',
			'search'	=> new View_Data_Search($this->fields()),
		));
	}
	
	/**
	 * Render the toolbar for the action.
	 * @param string $action
	 * @param integer $id
	 */
	protected function toolbar($action = NULL)
	{
		$toolbar = $this->{'toolbar_'.$action}();
		
		$datatoolbar = new View_Data_DataToolbar();
		
		$datatoolbar->set(array(
			'toolbar_selection_fixed' => Arr::get($toolbar, 'fixed'),
			'toolbar_selection_one'   => Arr::get($toolbar, 'one'),
			'toolbar_selection_many'  => Arr::get($toolbar, 'many'),
			'toolbar_table' 		  => Arr::get($toolbar, 'table'),
		));
		
		return $datatoolbar;
	}
	
	/**
	 * Subtitle for the page. 
	 * This is a function so that Kohana::message() may be used.
	 */
	abstract protected function subtitle();
	
	protected function route($return = TRUE, $route_action = '', $route_id = NULL)
	{
		$url = Route::url($this->route_name, array(
			'directory'		=> $this->request->directory(),
			'controller'	=> $this->request->controller(),
			'action'		=> $route_action,
			'id'			=> $route_id,
		));
	
		if ($return)
		{
			// Even if the request is a Post, "return" comes from the query string
			$url .= base64_decode($this->request->query('return'));
		}
	
		return $url;
	}
	
}