<?php defined('SYSPATH') or die('No direct script access.');

class Login_View_Page_User_Edit extends Abstract_View_Page {

	/**
	 * @var Model_User
	 */
	public $user;
	public $errors = array();

	public function has_errors()
	{
		return (bool) $this->errors();
	}

	public function errors()
	{
		$errors = array();
		foreach ($this->errors as $key => $error)
		{
			$errors[] = array('key' => $key, 'error' => $error);
		}

		return $errors;
	}

	public function username()
	{
		return array(
			'name' => 'username',
			'value' => Arr::get($this->user, 'username'),
			'id' => 'username',
			'label' => Kohana::message('user', 'username.label'),
			'has_error' => Arr::get($this->errors, 'username'),
			'error' => Arr::get($this->errors, 'username'),
		);
	}

	public function email()
	{
		return array(
			'name' => 'email',
			'value' => Arr::get($this->user, 'email'),
			'id' => 'email',
			'label' => Kohana::message('user', 'email.label'),
			'has_error' => Arr::get($this->errors, 'email'),
			'error' => Arr::get($this->errors, 'email'),
		);
	}

}
